program cas2ttp;
{
CAS2TTP
Program to convert TVC emulator files (CAS) to (TTP).
The code is freeware.

Programmed by Varga Viktor (viktor.varga@gmail.com
Based on the converter of Laszlo Jozsef
Thanks to Kiss Karoly for some help.
}

{most of the functions were removed from the
CAS2WAV original, and simply without headers
were the bytes writen, with the MAGIC const header
}

type
  mymem = array[0..65520] of byte;
 pmymem = ^mymem;

const

hd : array[0..15] of char='0123456789ABCDEF';
MAGIC : string ='TTP0';

var

  infile : file;
 outfile : file;
  wrtcnt : longint;

   pfind : 0..65520;
   bl_id : byte;
   bl_sz : word;
   bl_nr : word;
    perr : byte;
     whd : pointer;
    CCRC : word;
   zCRC, TCRC,dfsize,lof : word;
    lofname,bihs: integer;
    tvcname: string;
      vnum: byte;
    secnum: byte;
    typecas,casauto :byte;
    sizecas: word;

   inbuff : pmymem;

   bitcount : longint;
   bitstore : longint;
   long: boolean;


{hexadecimalis atalakito fuggveny - ok}
function hex(x:byte):string;
begin
     hex:=hd[x shr 4]+hd[x and 15];
end;
{$R-}
{crc szamito rutin -direkt forditas - ok
z=0 v 1; hl=word}
function crccalc (bit:byte; hl:word):word;
var
    al: byte;
    cy: boolean;
    bx: word;
begin
    bx := hl;                { mov  bx,hl }
    if bit<>0 then al := $80  { mov  al,$80 }
    else           al := $00; { xor  al,al  }

    al := al xor (bx shr 8); { xor  al,bh  }
    cy := (al AND $80) <> 0; { rcl  al,1   }

    if (cy) then begin       { jnc  @fb0a  }
        bx := bx xor $0810;  { mov  al,bh  }
                             { xor  al,$08 }
                             { mov  bh,al  }
                             { mov  al,bl  }
                             { xor  al,$10 }
                             { mov  bl,al  }
                             { stc         }
    end;                     { @fb0a:      }
    bx := bx shl 1;          { adc  bx,bx  }
    if (cy) then inc (bx);
    crccalc := bx;           { mov  ax,bx  }
end;

{$R+}

procedure msg (s:string);
begin
 writeln(s);
 inc(perr);
end;


procedure write_bit(bt:byte);
begin
 case (bt and 1) of
 0: CCRC:=crcCalc(0,CCRC);
 1: CCRC:=crcCalc(1,CCRC);
 end;
end;


procedure write_byte(b:byte);
var
   x,i : byte;
begin
 x:=b;
 for i:=0 to 7 do
  begin

   write_bit(x);
   x:=x shr 1;
  end;
  blockwrite(outfile,b,1);
  write(hex(b),' ');
  inc(wrtcnt,1);
end;

procedure write_word(w:word);
begin
 write_byte(lo(w));
 write_byte(hi(w));
end;

procedure write_string(s:string);
var
   i : byte;
begin
 for i:=1 to length(s) do write_byte(ord(s[i]));
end;


function get_next:byte;
begin
 get_next:=inbuff^[pfind];
 inc(pfind);
end;


function getbyte:byte;
var b:byte;
begin
 blockread(infile, b,1);
 getbyte:=b;
end;

procedure write_tvc_headblock;
var
   i: integer;
   zCRC: word;
begin


if long then writeln;
if long then writeln('- Head block writing');


Write_byte(0);
CCRC:=0;          {clear calculated CRC}
write_byte($6a);
if long then Writeln('- Standard start bytes - $00 $6A ');

write_byte($ff); {head tmb}
if long then Writeln('- Head tmb - $FF');

write_byte($11); {non puffered}
if long then Writeln('- Non Puffered file - $11');

write_byte(0);   {non writeprotected}
if long then Writeln('- Non WriteProtected - $00');

write_byte(1);   {1 sector in this tmb}
if long then Writeln('- One Sector in Head - $01');

write_byte(secnum);   {sector number =0}
if long then Writeln('- Sector number: $',hex(secnum),'(',secnum,')');

lofname:=length(tvcname);
bihs:=1+lofname+16;
lof:=dfsize;
{dont know why, but it is needed to create a good file size into the wav
if a wav2cas a file back, it is a difference}

write_byte(bihs); {bytes in this sector}
if long then Writeln('- Bytes in head $',hex(bihs),'(',bihs,')');

write_byte(lofname);
if long then Writeln('- Length of filename $',hex(lofname),'(',lofname,')');

write_string(tvcname);
if long then Writeln('- Filename in TTP file: "',tvcname,'"');

write_byte(0);
if long then Writeln('- Standard fill byte - $00');

write_byte(typecas);
if long then Writeln('- File type: $',hex(typecas),'(',typecas,')');
write_word(lof);
if long then Writeln('- Length of file: $',hex(hi(lof)),hex(lo(lof)),'(',lof,')');

write_byte($00); {not autostarted}
if long then Writeln('- Program file is not autostarting - $00');

for i:=6 to 15 do write_byte(0);
if long then Writeln('- Standard Filling bytes - $00 .. $00');
vnum:=0;
write_byte(vnum);
if long then Writeln('- TVC file version number: $',hex(vnum),'(',vnum,')');
write_byte($00); {not last sector}
If long then Writeln('- This is not the last sector - $00');
zCRC := CCRC;
write_byte(lo(zCRC));
write_byte(hi(zCRC));
end;

procedure write_tvc_datahead;
var
   i: integer;
begin

if long then writeln;
if long then writeln('- Data Block Head');


write_byte(0);
CCRC:=0;
write_byte($6a);
if long then Writeln('- Standard Start Bytes - $00 $6A');

write_byte(0); {data tmb}
if long then Writeln('- Data Tmb - $00');

write_byte($11); {non puffered}
if long then Writeln('- Non Puffered File - $11');

write_byte(0);   {non writeprotected}
if long then Writeln('- Non Write Protected - $00');

write_byte((dfsize div 256)+1);   {sector in this tmb}
if long then Writeln('- Number of sectors in this tmb $',hex(((dfsize div 256)+1)));
if long then writeln;
end;

procedure write_tvc_datasec(size:byte);
var
   h,l : word;
   i : word;
begin
 if perr<>0 then exit;
 if secnum>1 then CCRC:=0;
 write_byte(secnum);
 write_byte(size);
 if size=0 then
           begin
                for i:=0 to 256 do write_byte(get_next);
                write_byte($00);

           end
 else
           begin
                for i:=0 to size-1 do write_byte(get_next);
                write_byte($ff);
           end;
 zCRC := CCRC;
 write_byte(lo(zCRC));
 write_byte(hi(zCRC));
end;

procedure write_ttp_file;
var
        b,bl,bh,bsl,bsh,brl,brh: byte;
        l : word;
        i,j : integer;
begin
 new(inbuff);

 perr:=0;


 b:=getbyte; {file id, must be $11}
 if b<>$11 then msg('! File ID error');
 b:=getbyte; { $00 - ignore }
 bsl := getbyte;
 bsh := getbyte;
 brl := getbyte;
 brh := getbyte;
 dfsize:=(bsl+bsh*256)*128 + (brl+brh*256);
 {cant get the real size, bu this is working, i dont understand why}
 if long then Writeln('- Size stored at the start of CAS file: ',dfsize);
{file size from $80 blocks plus modulus}

 for i:=$05 to $7f do b:=getbyte;
 {seeking to $80}


 if long then writeln('- File size stored at the head of the CAS file: $',hex(hi(dfsize)),hex(lo(dfsize)),' (',dfsize,')');
 dec(dfsize,$90);
{ inc(dfsize,30); }
 if long then writeln('- Tape data bytes in CAS file, without header (-$90): $',hex(hi(dfsize)),hex(lo(dfsize)),' (',dfsize,')');
 writeln;

 typecas:=getbyte;
 if long then writeln('- Casette type stored in CAS header: $',hex(typecas));
 bl := getbyte;
 bh := getbyte;
 sizecas:=bh*256+bl;
 if long then writeln('- Casette size stored in CAS header: $',hex(hi(sizecas)),hex(lo(sizecas)),' (',sizecas,')');
 casauto:=getbyte;
 if long then writeln('- Autostart byte stored in CAS header: $',hex(casauto));

 for i:=$85 to $8F do b:=getbyte;

 blockread(infile,inbuff^,dfsize); {read the entire tvc file (all databytes) }
 pfind:=0;

 secnum:=0;

 write_tvc_headblock;

 write_tvc_datahead;

 if long then writeln;
 if long then writeln('- Data sectors');

 secnum:=1;
 write_tvc_datasec(0); {first datasectors CRC includes head data CRC}
 if long then writeln('- Writing data sector: $',hex(secnum),'(',secnum,')');

 for secnum:=2 to (dfsize div 256) do
 begin
      if long then writeln('- Writing data sector: $',hex(secnum),'(',secnum,')');
      {writing out the full data sectors}
      write_tvc_datasec(0);
 end;

 {writing out the last data sector}
 inc(secnum,1);

 write_tvc_datasec(dfsize mod 256);
 if long then writeln('- Writing data sector: $',hex(secnum),'. This is a smaller sector.');


 if long then writeln;
 if long then writeln('- File write done. ($',hex(secnum),' (',secnum,') sectors)');

 dispose(inbuff);
end;

BEGIN


long:=false;

assign(output,'');
rewrite(output);

 wrtcnt:=0;
 if paramcount<2 then
  begin
   Writeln('TVC CAS file to TTP converter.');
   Writeln('Version 1.0 Build 081118');
   Writeln;
   writeln('USE: cas2ttp -l|-x CAS-file TTP-file [fname]');
   Writeln;
   Writeln('     CAS-file: TVC emulator file');
   Writeln('     TTP-file: destination file');
   Writeln('     fname : the filename store into the TTP file, ');
   Writeln('             if empty, then created from the PC file name, without extension.');
   Writeln;
   halt;
  end;

 assign( infile,paramstr(2));
 assign(outfile,paramstr(3));

 if paramstr(1)='-l' then long:=true else
     if paramstr(1)<>'-x' then begin
                                Writeln('Second paramter missign.');
                                halt;
                          end;

 if paramstr(4)<>'' then begin
 tvcname:=upcase(paramstr(4));
 tvcname:=Copy(tvcname,1,16);
 end
 else
 tvcname:=upcase(Copy(paramstr(2),1,(length(paramstr(2))-4)));

 perr:=0;
 {$I-}
 reset(infile,1);
 if IOresult<>0 then msg('! Input file open error');
 rewrite(outfile,1);
 if IOresult<>0 then msg('! Output file creation error');
 {$I+}



 if perr<>0 then halt;

 wrtcnt:=0;

 write_string(MAGIC);
 seek(infile,0);
 write_ttp_file;



 if long then Writeln('- File size should be: ', wrtcnt);
 { correct wav size parameters }

 if paramstr(1)='-x' then writeln(upcase (paramstr(2)),' -> ',upcase(paramstr(3)),' [',tvcname,']');
 close(infile);
 close(outfile);

Writeln;
Writeln('HTTP://TVC.HOMESERVER.HU');
Writeln('HTTP://TVC.8BIT.HU');
Writeln;
Writeln('Ne felejtsd elkuldeni nekunk, ha olyan');
Writeln('programod van, ami nincs a weboldalon.');
Writeln;
Writeln('Don''t forget to send us, if you have a');
Writeln('software that we have not on the website.');
Writeln;
Writeln('Freeware program and source made by Kiss Karoly and Varga Viktor.');
close(output);
END.
