program ttp2wav;
{
TTP2WAV
Program to convert TVC emulator files (TTP) to WAV.
It is transferable after back to the original computer.
The code is freeware.

Programmed by Varga Viktor (viktor.varga@gmail.com)
Based on the converter of Laszlo Jozsef
Thanks to Kiss Karoly for some help.
}

type
  mymem = array[0..65520] of byte;
 pmymem = ^mymem;

const

hd : array[0..15] of char='0123456789ABCDEF';

  SILENCE = $80;
 POS_PEAK = $f8;
 NEG_PEAK = $08;


 bt1 : array[0..15] of byte=(POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK);

 bt0 : array[0..21] of byte=(POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK);

 pre : array[0..17] of byte=(POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK);

 syn : array[0..33] of byte=(POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,POS_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,
                             NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK,NEG_PEAK);
 wavheader: array [1..44] of byte=(
        $52,$49,$46,$46,$00,$00,$00,$00,$57,$41,$56,$45,$66,$6d,$74,$20,
        $10,$00,$00,$00,$01,$00,$01,$00,$44,$ac,$00,$00,$44,$ac,$00,$00,
        $01,$00,$08,$00,$64,$61,$74,$61,$00,$00,$00,$00);

 MAGIC:string=('TTP0');
                             {
 wavheader, 44 bajt, mono 44100 Hz-es wav fajl fejlec


 TVC "0" bit, 552 usec: 11 high 11 low
 TVC "1" bit, 388 usec: 8 high 8 low

 TVC pre sound, 470 usec, 9 high 9 low
 TVC syncrone, 736 usec, 14 hig 14 low
 -this was change to longer (16-16) to be comaptible with wav2cas

 TVC Headblock
 0) 2 sec silence
 1) 10240 pre sound
 2) 1 syncrone
 3) Head data
 4) 5 pre sound

 TVC Datablock
 0) 1 sec silence
 1) 5120 pre sound
 2) 1 syncrone
 3) Data data
 4) 5 pre sound

 1 sec silence =  44100 silence


}

var

  infile : file;
 outfile : file;
  wrtcnt : longint;
   pfind : 0..65520;
   bl_id : byte;
   bl_sz : word;
   bl_nr : word;
    perr : byte;
     whd : pointer;
    CCRC : word;
   zCRC, TCRC,dfsize,lof : word;
    lofname,bihs: integer;
    tvcname: string;
      vnum: byte;
    secnum: byte;
    typecas,casauto :byte;
    sizecas: word;
         s:string;
   inbuff : pmymem;
    long:boolean;
    b:byte;
    w:word;


{-
  $L wavhead.obj-
procedure wavheader; external;
(a fajlokban a $40 $1f (22khz) kicserelsre kerult $44 $ac (44,1khz))

this block was removed for freepascal compatibility,
replaced with the constant

}

{hexadecimalis atalakito fuggveny - ok}
function hex(x:byte):string;
begin
     hex:=hd[x shr 4]+hd[x and 15];
end;
{$R-}
{crc szamito rutin -direkt forditas - ok
z=0 v 1; hl=word}
function crccalc (bit:byte; hl:word):word;
var
    al: byte;
    cy: boolean;
    bx: word;
begin
    bx := hl;                { mov  bx,hl }
    if bit<>0 then al := $80  { mov  al,$80 }
    else           al := $00; { xor  al,al  }

    al := al xor (bx shr 8); { xor  al,bh  }
    cy := (al AND $80) <> 0; { rcl  al,1   }

    if (cy) then begin       { jnc  @fb0a  }
        bx := bx xor $0810;  { mov  al,bh  }
                             { xor  al,$08 }
                             { mov  bh,al  }
                             { mov  al,bl  }
                             { xor  al,$10 }
                             { mov  bl,al  }
                             { stc         }
    end;                     { @fb0a:      }
    bx := bx shl 1;          { adc  bx,bx  }
    if (cy) then inc (bx);
    crccalc := bx;           { mov  ax,bx  }
end;
{$R+}
procedure msg (s:string);
begin
 writeln(s);
 inc(perr);
end;

procedure write_tvc_silence;
var
 bf : array[0..11025] of byte;
begin
 if perr<>0 then exit;

 if long then writeln('- Writing 1 sec silence');

 fillchar(bf,sizeof(bf),SILENCE);
 blockwrite(outfile,bf,sizeof(bf)); {1 sec}
 blockwrite(outfile,bf,sizeof(bf));

 inc(wrtcnt,sizeof(bf));
 inc(wrtcnt,sizeof(bf));
end;


procedure write_bit(bt:byte);
begin
 case (bt and 1) of
 0:
   begin
    blockwrite(outfile,bt0,sizeof(bt0));
    inc(wrtcnt,sizeof(bt0));
    CCRC:=crcCalc(0,CCRC);
   end;
 1:
   begin
    blockwrite(outfile,bt1,sizeof(bt1));
    inc(wrtcnt,sizeof(bt1));
    CCRC:=crcCalc(1,CCRC);
   end;
 end;
end;

procedure write_pre(db:integer);
var i:integer;
begin
if long then writeln('- Writing out ',db,' intro/after pulses');
for i:=1 to db do
    begin
         blockwrite(outfile,pre,sizeof(pre));
         inc(wrtcnt,sizeof(pre));
    end;
end;

procedure write_tvc_syncrone;
begin
     blockwrite(outfile,syn,sizeof(syn));
     inc(wrtcnt,sizeof(syn));

end;
{$R-}
procedure write_byte(b:byte);
var
   x,i : byte;
begin
 x:=b;
 for i:=0 to 7 do
  begin

   write_bit(x);
   x:=x shr 1;

  end;
{   write( hex( b),' ');}
end;
{$R+}

procedure write_word(w:word);
begin
 write_byte(lo(w));
 write_byte(hi(w));
end;

procedure write_string(s:string);
var
   i : byte;
begin
 for i:=1 to length(s) do write_byte(ord(s[i]));
end;

procedure write_tvc_headpre;
begin
write_pre(10240);
end;

procedure write_tvc_datapre;
begin
write_pre(5120);
end;

procedure write_tvc_after;
begin
write_pre(5);
end;

function  get_next:byte;
begin
 get_next:=inbuff^[pfind];
 inc(pfind);
end;

function getbyte:byte;
var b:byte;
begin
 blockread(infile, b,1);
 getbyte:=b;
end;

procedure write_tvc_headblock;
var
   i: integer;
   zCRC: word;
begin

write_tvc_silence;
write_tvc_silence;

if long then writeln;
if long then writeln('= Head block writing');

write_tvc_headpre;

write_tvc_syncrone;


if getbyte<>0 then Writeln('! Not a good TTP structure.');
Write_byte(0);

CCRC:=0;          {clear calculated CRC}

if getbyte<>$6a then Writeln('! Not a good TTP structure.');
write_byte($6a);
if long then Writeln('- Standard start bytes $00 $6A');

if getbyte<>$ff then Writeln('! Not a good TTP structure.');
write_byte($ff); {head tmb}
if long then Writeln('- Head tmb $FF');

b:=getbyte;
write_byte(b); {non puffered}
if b<>$11 then
Writeln('! Another than non puffered file. $',hex(b))
else
if long then Writeln('- Non puffered file $11');



b:=getbyte;
write_byte(b);   {non writeprotected}
if b<>0 then Writeln('! Another than non writeprotected. $',hex(b))
else
if long then Writeln('- Non writeprotected $00');



b:=getbyte;
write_byte(b);   {haed sec number}
if b<>1 then Writeln('! Maybe bug, head sector larger than 1? $',hex(b))
else
if long then Writeln('- One sector in the head $01');


secnum:=getbyte;
write_byte(secnum);   {sector number}
if long then Writeln('- Sector number $',hex(secnum),' (',secnum,')');


{lofname:=length(tvcname);
bihs:=1+lofname+16;
lof:=dfsize;}

{dont know why, but it is needed to create a good file size into the wav
if a wav2cas a file back, it is a difference}

bihs:=getbyte;
lofname:=getbyte;
if bihs<>lofname+17 then writeln ('! Byte in this sector not correct?')
else Writeln('- Byte in this sector counter is correct.');
bihs:=lofname+17;

write_byte(bihs); {bytes in this sector}
if long then Writeln('- Bytes in head $',hex(bihs),' (',bihs,')');

write_byte(lofname);
if long then Writeln('- Length of filename $',hex(lofname),' (',lofname,')');

for i:=1 to lofname do tvcname[i]:=chr(getbyte);
tvcname[0]:=chr(lofname);
write_string(tvcname);
if long then Writeln('- Filename in wav: "',tvcname,'"');

b:=getbyte;
write_byte(b);   {filling zero}
if b<>0 then Writeln('! Filling zero missing? $',hex(b))
else
if long then Writeln('- Standard fill byte $00');


typecas:=getbyte;
write_byte(typecas);   {cas type}
if typecas<>1 then Writeln('! Maybe not a program file? $',hex(b))
else
if long then Writeln('- File type $',hex(typecas));


lof:=getbyte+getbyte*256;
write_word(lof);
if long then Writeln('- Length of file $',hex(hi(lof)),hex(lo(lof)),' (',lof,')');

dfsize:=lof;

b:=getbyte;
write_byte(b);   {not autostarted}
if b<>0 then Writeln('! Autostarting program? $',hex(b))
else
if long then Writeln('- Not autostarting program $00');


for i:=6 to 15 do write_byte(getbyte);
if long then Writeln('- Standard filling bytes $00 .. $00');


vnum:=getbyte;
write_byte(vnum);   {file version numbernot autostarted}
if vnum<>0 then Writeln('! Version number used? $',hex(vnum))
else
if long then Writeln('- Tvc file version number: $',hex(vnum),' (',vnum,')');


b:=getbyte;
write_byte(b);   {not a last sector, because $00 is in it}
if b<>0 then Writeln('! Last sector? $',hex(b))
else
if long then Writeln('- Not a last sector $00');


zCRC := CCRC;
write_byte(lo(zCRC));
write_byte(hi(zCRC));

w:=getbyte+getbyte*256;

if w<>zCRC then
begin
        Writeln ('! CRC error, original $',hex(hi(zCRC)),hex(lo(zCRC)),', calculated: $',hex(hi(w)),hex(lo(w)));
end
else Writeln ('- CRC is correct');

write_tvc_after;
end;

procedure write_tvc_datahead;
var
   i: integer;
begin
write_tvc_silence;

if long then writeln;
if long then writeln('= Data block head');

write_tvc_datapre;
write_tvc_syncrone;

if getbyte<>0 then Writeln('! Not a good TTP structure.');
Write_byte(0);

CCRC:=0;          {clear calculated CRC}

if getbyte<>$6a then Writeln('! Not a good TTP structure.');
write_byte($6a);
if long then Writeln('- Standard start bytes $00 $6A');

if getbyte<>$00 then Writeln('! Not a good TTP structure.');
write_byte($0); {head tmb}
if long then Writeln('- Data tmb $00');

b:=getbyte;
write_byte(b); {non puffered}
if b<>$11 then
Writeln('! Another than non puffered file. $',hex(b))
else
if long then Writeln('- Non puffered file $11');


b:=getbyte;
write_byte(b);   {non writeprotected}
if b<>0 then Writeln('! Another than non writeprotected. $',hex(b))
else
if long then Writeln('- Non writeprotected $00');


write_byte((dfsize div 256)+1);   {sector in this tmb}
if long then Writeln('- number of sectors in this tmb $',hex(((dfsize div 256)+1)));
if long then writeln;
if long then Writeln('- number of sectors in this tmb regarding original file: $',hex(getbyte));
if long then writeln;

end;

procedure write_tvc_datasec(size:byte);
var
   h,l : word;
   i : word;
begin
 if perr<>0 then exit;
 if secnum>1 then CCRC:=0;
 b:=getbyte;
 if long then Writeln('- Sector number from file: ',hex(b));
 write_byte(secnum);

 b:=getbyte;
 if long then Writeln('- Sector size from file: ',hex(b));
 write_byte(size);

 if size=0 then
           begin
                for i:=0 to 256 do write_byte(getbyte);
                b:=getbyte;
                write_byte($00);

           end
 else
           begin
                for i:=0 to size-1 do write_byte(getbyte);
                b:=getbyte;
                write_byte($ff);
           end;


 w:=getbyte+getbyte*256;
 zCRC := CCRC;
 if w<>zCRC then
begin
        Writeln ('! CRC error, original $',hex(hi(zCRC)),hex(lo(zCRC)),', calculated: $',hex(hi(w)),hex(lo(w)));
end
else Writeln ('- CRC is correct');


 write_byte(lo(zCRC));
 write_byte(hi(zCRC));


end;

procedure write_tvc_file;
var
        b,bl,bh,bsl,bsh,brl,brh: byte;
        l : word;
        i,j : integer;
begin
 new(inbuff);

 perr:=0;

 for i:=1 to 4 do
 s[i]:=chr(getbyte);
 s[0]:=chr(4);

 if s<>MAGIC then msg('! File ID error');


 blockread(infile,inbuff^,dfsize); {read the entire tvc file (all databytes) }
 pfind:=0;

 secnum:=0;

 write_tvc_headblock;

 write_tvc_datahead;


 writeln;
 if long then writeln('= Data sectors');

 secnum:=1;
 if long then writeln('- Data sector writing $',hex(secnum),' (',secnum,')');
 write_tvc_datasec(0); {first datasectors CRC includes head data CRC}

 for secnum:=2 to (dfsize div 256) do
 begin
       if long then writeln('- Data sector writing $',hex(secnum),' (',secnum,')');
      {writing out the full data sectors}
      write_tvc_datasec(0);
 end;

 {writing out the last data sector}
 inc(secnum,1);

 write_tvc_datasec(dfsize mod 256);
 if long then writeln('- Last, not full size data sector writing $',hex(secnum),' (',secnum,')');

 write_tvc_after; {putting out the last five signal}
 write_tvc_silence;
 write_tvc_silence;

 writeln;
 if long then writeln('- File write done. ($',hex(secnum),' (',secnum,') sectors)');

 dispose(inbuff);
end;

BEGIN

assign(output,'');
rewrite(output);

 wrtcnt:=0;
 if paramcount<2 then
  begin
   Writeln('TVC TTP file to WAV converter.');
   Writeln('Version 1.0 Build 081118');
   Writeln;
   writeln('USE: ttp2wav [-l] TTP-file WAV-file');
   Writeln;
   Writeln('     TTP-file: TVC emulator file');
   Writeln('     Wav-file: destination file');
   Writeln('     -l : detailed conversion info');
   Writeln;
   halt;
  end;


 if paramstr(1)='-l' then
 begin
        long:=true;
        assign( infile,paramstr(2));
        assign(outfile,paramstr(3));
 end
 else
 begin
  assign( infile,paramstr(1));
  assign(outfile,paramstr(2));
 end;

 perr:=0;
 {$I-}
 reset(infile,1);
 if IOresult<>0 then msg('! Input file open error');
 rewrite(outfile,1);
 if IOresult<>0 then msg('! Output file creation error');
 {$I+}

 if perr<>0 then halt;



 whd:=@wavheader;
 blockwrite(outfile,whd^,44);

 wrtcnt:=0;

 write_tvc_file;

 if long then Writeln('- Writed pulses:',wrtcnt);
 if long then Writeln('- WAV file size should be:', wrtcnt+44);
 { correct wav size parameters }
 seek(outfile,40);
 blockwrite(outfile,wrtcnt,4); { data field size }
 seek(outfile,4);
 inc(wrtcnt,$24);
 blockwrite(outfile,wrtcnt,4); { RIFF field size }

 close(infile);
 close(outfile);

 if not(long) then Writeln(paramstr(1),' -> ',paramstr(2));

Writeln;
Writeln('HTTP://TVC.HOMESERVER.HU');
Writeln('HTTP://TVC.8BIT.HU');
Writeln;
Writeln('Ne felejtsd elkuldeni nekunk, ha olyan');
Writeln('programod van, ami nincs a weboldalon.');
Writeln;
Writeln('Don''t forget to send us, if you have a');
Writeln('software that we have not on the website.');
Writeln;
Writeln('Freeware software and source from Kiss Karoly nad Varga Viktor.');
close(output);
END. of program
